package org.simantics.scl.compiler.constants;

import org.objectweb.asm.Label;
import org.simantics.scl.compiler.internal.codegen.references.Val;
import org.simantics.scl.compiler.internal.codegen.utils.MethodBuilder;
import org.simantics.scl.compiler.types.TVar;
import org.simantics.scl.compiler.types.Type;
import org.simantics.scl.compiler.types.Types;

public class JavaComparisonToZeroOperation extends FunctionValue {
    
    String op;
    
    public JavaComparisonToZeroOperation(String op) {
        super(TVar.EMPTY_ARRAY, Types.NO_EFFECTS, Types.BOOLEAN, Types.INTEGER);
        this.op = op;
    }

    @Override
    public Type applyExact(MethodBuilder mb, Val[] parameters) {
        Label thenBranch = mb.createLabel();
        Label joinPoint = mb.createLabel();
        
        mb.push(parameters[0], Types.INTEGER);        
        mb.ifZeroComparisonBranch(thenBranch, op);
        
        mb.loadConstant(false);
        mb.branch(joinPoint);
        
        mb.setLocation(thenBranch);
        mb.loadConstant(true);
        mb.setLocation(joinPoint);
        
        return getReturnType();
    }
    
    @Override
    public String toString() {
        return op;
    }

}
