package org.simantics.scl.compiler.source.repository;

import org.simantics.scl.compiler.module.repository.ModuleRepository;
import org.simantics.scl.compiler.module.repository.UpdateListener;
import org.simantics.scl.compiler.source.ModuleSource;

import gnu.trove.procedure.TObjectProcedure;

/**
 * An interface for locating modules descriptors and listening if they change.
 * An instance of this interface is used to create a {@link ModuleRepository}.
 * 
 * @author Hannu Niemist&ouml;
 */
public interface ModuleSourceRepository {
    ModuleSource getModuleSource(String moduleName, UpdateListener listener);
    void forAllModules(TObjectProcedure<String> procedure);
    String getDocumentation(String documentationName);
    void forAllDocumentations(TObjectProcedure<String> procedure);
    void checkUpdates();
    void clear();
}
